#ifndef CHISTMANAGER_HH
#define CHISTMANAGER_HH

#include "TAttFill.h"

#include <string>

#include "IArrayManager.hh"

class TH1;
class CCreateHist;

class CHistManager : public IArrayManager
{
  friend class CCreateHist;

public:
  CHistManager() : IArrayManager(), fdrawOptionDef("COLZBARBOX"), ffillColorDef(7)
  {
    IArrayManager::listname = "histmanager";
    SetDrawOption();
    SetFillColor();
  }
  ~CHistManager(){;}

  TH1* GetHist(int id);
  TH1* GetHist(std::string name);
  TH1* GetHist();
  void GetNameXYZ(std::string title, std::string& namex, std::string& namey, std::string& namez);
  std::string GetNameX();
  std::string GetNameY();
  std::string GetNameZ();
  void Insert(std::string name, std::string title, int order, int id = -1);
  void InsertAfterCurrent(std::string name, std::string title);
  void Insert(TFile* file, int offset);
  void Draw(std::string name);
  void Draw(int id);
  void Write();
  void SetDrawOption(std::string foption);
  void SetDrawOption();
  void ApplyOption(std::string name);
  void ApplyOption(int id);
  void ApplyOption();
  void ApplyOptionAll();
  void SetFillColor(Color_t fcolor);
  void SetFillColor();

private:
  std::string Split(std::string& str, std::string keyword);

  const std::string fdrawOptionDef;  
  std::string fdrawOption;
  const Color_t ffillColorDef;
  Color_t ffillColor;

private:
  std::string FunctionName(std::string functionname) const;
};

#endif
