
#include <iostream>
#include <iomanip>
#include <sstream>

#include "TROOT.h"
#include "TObject.h"

#include "NGlobal.hh"

void NGlobal::IncrementName(std::string& name)
{
  if(name.empty()){
    std::ostringstream os;
    os << NGlobal::FunctionName("IncrementName") << "empty name is not allowed";
    Message(os.str(), kMID);

    return;
  }

  TObject* obj = gROOT->FindObject(name.c_str());

  if(!obj){
    std::ostringstream os;
    os << NGlobal::FunctionName("IncrementName") << name << "dosn't exist";
    Message(os.str(), kLOW);

    return;
  }else{
    std::ostringstream os;
    os << NGlobal::FunctionName("IncrementName")
       << name << " already exist." << " Increament name.";
    Message(os.str(), kMID);
    
    name += "_";
    IncrementName(name);
  }
}

void NGlobal::Message(std::string message, EMessageLevel level)
{
  if(level >= kMID){ 
    std::cout << message << std::endl;
  }
}

std::string NGlobal::FunctionName(std::string functionname)
{
  return "[NGlobal::" + functionname + "]$ ";
}

