
#include <vector>

#include "GConverterRdfToTxt.hh"
#include "CConvertFile.hh"
#include "CConverterRdfToTxt.hh"

#include "NConverter.hh"

void NConverter::ConvertRdfToTxt(std::string InputFileName, std::string OutputFileName)
{
  CConvertFile* file_in = new CConvertFile(InputFileName, "rb");
  if(!file_in->IsOpen()){
    delete file_in;
    return;
  }
  CConvertFile* file_out = new CConvertFile(OutputFileName, "w");
  if(!file_out->IsOpen()){
    delete file_out;
    delete file_in;
    return;
  }
  CConverterRdfToTxt* converter = new CConverterRdfToTxt();

  converter->SetFile(file_in, "in");
  converter->SetFile(file_out, "out");

  converter->Convert();

  delete converter;
  delete file_out;
  delete file_in;

  printf("\n conversion is done!!\n\n");
}

void  NConverter::ConvertRdfToVector(std::string InputFileName,
				     std::vector<std::vector<int> >& eventbuffer)
{
  CConvertFile* file_in = new CConvertFile(InputFileName, "rb");
  if(!file_in->IsOpen()){
    delete file_in;
    return;
  }
  CConverterRdfToTxt* converter = new CConverterRdfToTxt();

  converter->SetFile(file_in, "in");

  converter->ConvertOnMemory(eventbuffer);

  delete converter;
  delete file_in;

  printf("\n conversion is done!!\n\n");
}

  //local test
#if 0

int main(int argc, char *argv[])
{
  CConvertFile* file_in;
  CConvertFile* file_out;
  CConverterRdfToTxt* converter;

  file_in = new CConvertFile();
  file_out = new CConvertFile();
  file_in->fopen_rb("nadeko.rdf");
  file_out->fopen_w("temp.txt");

  converter = new CConverterRdfToTxt();

  converter->SetFile(file_in, "in");
  converter->SetFile(file_out, "out");

  converter->Convert();

  delete converter;
  delete file_out;
  delete file_in;

  printf("\n conversion is done!!\n\n");
  
  return 0;
}

#endif
