#ifndef CCREATEHIST_HH
#define CCREATEHIST_HH

#include "CdequeIdNameTitle.hh"

class TCut;

class CCanvasManager;
class CHistManager;
class CBranchManager;

namespace NAlias
{
  extern CCanvasManager* canvasmanager;
  extern CHistManager* histmanager;
  extern CBranchManager* branchmanager;
}

class CCreateHist
{
public:
  CCreateHist(){;}
  ~CCreateHist(){;}
  void CreateHistFromBranch(int idx,
			    Int_t nbinsx,
			    Double_t xlow,
			    Double_t xup,
			    int idy,
			    Int_t nbinsy,
			    Double_t ylow,
			    Double_t yup,
			    int idz,
			    Int_t nbinsz,
			    Double_t zlow,
			    Double_t zup,
			    std::string name = "",
			    const TCut* selection = 0);
  void CreateHistFromBranch(int idx,
			    Int_t nbinsx,
			    Double_t xlow,
			    Double_t xup,
			    int idy,
			    Int_t nbinsy,
			    Double_t ylow,
			    Double_t yup,
			    std::string name = "",
			    const TCut* selection = 0);
  void CreateHistFromBranch(int idx,
			    Int_t nbinsx,
			    Double_t xlow,
			    Double_t xup,
			    std::string name = "",
			    const TCut* selection = 0);
  void CreateHistFromBranch(std::string branchnamex,
			    std::string branchnamey = "",
			    std::string branchnamez = "",
			    std::string histname = "",
			    const TCut* selection = 0);
  void CreateHistFromBranch(int idx,
			    int idy = -1,
			    int idz = -1,
			    std::string histname = "",
			    const TCut* selection = 0);
  void CreateHistFromBranchAll();

  void CreateHistFromCurrentHist(std::string histname, const TCut* selection = 0);

private:
  void CreateHistFromBranchInnerFunc(std::string histname, std::string histtitle, const TCut* selection = 0);

private:
  std::string FunctionName(std::string functionname) const;
};

#endif
