#ifndef CMAPFUNCTION_HH
#define CMAPFUNCTION_HH

#include <deque>
#include <string>

#include "TF1.h"

class CMapFunction
{
public:
  CMapFunction();
  ~CMapFunction();

  virtual void SetFile(std::string filename) = 0;
  TF1* GetMapFunction();

protected:
  virtual Double_t MapFunction(Double_t* x, Double_t* par) = 0;
  void SetMap(const std::deque<Double_t>* f,
	      const std::deque<Double_t>* x,
	      const std::deque<Double_t>* y = 0,
	      const std::deque<Double_t>* z = 0);

protected:
  TF1* fMapFunction;
  std::deque<Double_t> fF, fX, fY, fZ;

  ClassDef(CMapFunction, 0)
};

#endif
