#ifndef CMAPFUNCTION1D_HH
#define CMAPFUNCTION1D_HH

#include <string>

#include "CMapFunction.hh"

class CMapFunction1D : public CMapFunction
{
public:
  CMapFunction1D();
  ~CMapFunction1D();

  void SetFile(std::string filename);

private:
  Double_t MapFunction(Double_t xx);
  Double_t MapFunction(Double_t* x, Double_t* /*par*/);

public:
  Double_t VRMF1D(Double_t xx, Double_t k, Double_t a, Double_t r0,
		  Double_t Eb, Double_t ma, Double_t mb);
  Double_t VRMF1D(Double_t* x, Double_t* par);

  Double_t BW2MF1D(Double_t xx, Double_t k, Double_t k1,
		   Double_t er1, Double_t gamma1,
		   Double_t er2, Double_t gamma2);
  Double_t BW2MF1D(Double_t* x, Double_t* par);

  Double_t VRBW2MF1D(Double_t xx, Double_t k,
		     Double_t a, Double_t r0, Double_t Eb, Double_t ma, Double_t mb,
		     Double_t k1, Double_t er1, Double_t gamma1,
		     Double_t k2, Double_t er2, Double_t gamma2);
  Double_t VRBW2MF1D(Double_t* x, Double_t* par);

  ClassDef(CMapFunction1D, 0)
};

#endif
