
#include <iostream>
#include <deque>
#include <fstream>
#include <cmath>

#include "TF1.h"
#include "TF2.h"

#include "CMapFunction2D.hh"
#include "FFunction.hh"

ClassImp(CMapFunction2D)

CMapFunction2D::CMapFunction2D() : CMapFunction()
{;}

CMapFunction2D::~CMapFunction2D()
{;}

void CMapFunction2D::SetFile(std::string filename)
{
  std::ifstream ifs(filename.c_str());
  Double_t f,x,y;
  std::deque<Double_t> df,dx,dy;
  while(!ifs.eof()){
    ifs >> x >> y >> f;
    df.push_back(f);
    dx.push_back(x);
    dy.push_back(y);
  }
  SetMap(&df,&dx,&dy);

  Double_t xmin,xmax;
  std::deque<Double_t>::const_iterator itx = fX.begin();
  xmin = *itx;
  std::deque<Double_t>::const_reverse_iterator ritx = fX.rbegin();
  xmax = *ritx;

  Double_t ymin,ymax;
  std::deque<Double_t>::const_iterator ity = fY.begin();
  ymin = *ity;
  std::deque<Double_t>::const_reverse_iterator rity = fY.rbegin();
  ymax = *rity;

  fMapFunction = new TF2("mapfunction2d", this,
			 static_cast<Double_t (CMapFunction2D::*)(Double_t*, Double_t*)>
			 (&CMapFunction2D::MapFunction),
			 xmin, xmax, ymin, ymax, 0, "CMapFunction2D", "MapFunction");
}

Double_t CMapFunction2D::MapFunction(Double_t /*xx*/, Double_t /*yy*/)
{
  std::cout << "not yet" << std::endl;

  return 0;
}

Double_t CMapFunction2D::MapFunction(Double_t* x, Double_t* /*par*/)
{
  Double_t xx = x[0];
  Double_t yy = x[1];
  
  return MapFunction(xx, yy);
}

