
#include <iostream>
#include <deque>
#include <fstream>
#include <cmath>

#include "TF1.h"
#include "TF3.h"

#include "CMapFunction3D.hh"
#include "FFunction.hh"

ClassImp(CMapFunction3D)

CMapFunction3D::CMapFunction3D() : CMapFunction()
{;}

CMapFunction3D::~CMapFunction3D()
{;}

void CMapFunction3D::SetFile(std::string filename)
{
  std::ifstream ifs(filename.c_str());
  Double_t f,x,y,z;
  std::deque<Double_t> df,dx,dy,dz;
  while(!ifs.eof()){
    ifs >> x >> y >> z >> f;
    df.push_back(f);
    dx.push_back(x);
    dy.push_back(y);
    dz.push_back(z);
  }
  SetMap(&df,&dx,&dy,&dz);

  Double_t xmin,xmax;
  std::deque<Double_t>::const_iterator itx = fX.begin();
  xmin = *itx;
  std::deque<Double_t>::const_reverse_iterator ritx = fX.rbegin();
  xmax = *ritx;

  Double_t ymin,ymax;
  std::deque<Double_t>::const_iterator ity = fY.begin();
  ymin = *ity;
  std::deque<Double_t>::const_reverse_iterator rity = fY.rbegin();
  ymax = *rity;

  Double_t zmin,zmax;
  std::deque<Double_t>::const_iterator itz = fZ.begin();
  zmin = *itz;
  std::deque<Double_t>::const_reverse_iterator ritz = fZ.rbegin();
  zmax = *ritz;

  fMapFunction = new TF3("mapfunction3d", this,
			   static_cast<Double_t (CMapFunction3D::*)(Double_t*, Double_t*)>
			   (&CMapFunction3D::MapFunction),
			   xmin, xmax, ymin, ymax, zmin, zmax, 0, "CMapFunction3D", "MapFunction");
}

Double_t CMapFunction3D::MapFunction(Double_t /*xx*/, Double_t /*yy*/, Double_t /*zz*/)
{
  std::cout << "not yet" << std::endl;

  return 0;
}

Double_t CMapFunction3D::MapFunction(Double_t* x, Double_t* /*par*/)
{
  Double_t xx = x[0];
  Double_t yy = x[1];
  Double_t zz = x[2];
  
  return MapFunction(xx, yy, zz);
}
