
#include <iostream>
#include <cstdlib>

#include "CParticleDefinition.hh"

ClassImp(CParticleDefinition)

const double CParticleDefinition::fAtomicMass(931.494);
std::vector<CParticle> CParticleDefinition::fParticle_v;

CParticleDefinition::CParticleDefinition(){/* nothing */;}

CParticleDefinition::~CParticleDefinition(){/* nothing */;}

CParticle CParticleDefinition::GetParticle(std::string name)
{
  int A;
  double massexcess;

  //memorize;
  std::vector<CParticle>::iterator it = fParticle_v.begin();
  while(it != fParticle_v.end()){
    if(it->GetName() == name){
      return *it;
    }
    ++it;
  }

  if(name == "proton"){
    A = 1;
    massexcess = 7.28897050;
  }else if(name == "neutron"){
    A = 1;
    massexcess = 8.0713171;
  }else if(name == "9Li"){
    A = 9;
    massexcess = 24.954264;
  }else if(name == "10Be"){
    A = 10;
    massexcess = 12.606670;
  }else if(name == "12C"){
    A = 12;
    massexcess = 0;
  }else{
    std::cout << name << " cannot be chosen" << std::endl;
    std::abort();
  }

  CParticle particle(fAtomicMass*A+massexcess, name);
  fParticle_v.push_back(particle);

  return fParticle_v.back();
}
